local mod_gui = require '__core__/lualib/mod-gui'
local on_player_created = function(event)
    local frame = mod_gui.get_frame_flow(game.get_player(event.player_index))
    if not frame.reset then
        frame.add{
            type = "button",
            name = "reset",
            caption = "Reset"
        }
        frame.add{
            type = "button",
            name = "clearIt",
            caption = "Clear"
        }
    end
    local testFrame = frame.add{
        type = "frame",
        caption = "Test",
        name = "testFrame",
    }
    local l1 = testFrame.add{
        type = "label",
        caption = "Height set",
    }
    l1.style.height = 30

    local l2 = testFrame.add{
        type = "label",
        caption = "Width set",
    }
    l2.style.width = 150

    local l3 = testFrame.add{
        type = "label",
        caption = "Both set",
    }
    l3.style.height = 30
    l3.style.width = 150

    -- local f = testFrame.add{
    --     type = "frame",
    -- }
    -- for i=1,2 do
    --     l1 = f.add{
    --         type = "label",
    --         caption = i % 2 *100,
    --     }
    --     l1.style.height = 15
    --     l1.style.width = 30
    -- end

    -- for i=1,2 do
    --     local t0 = testFrame.add{
    --         type = "choose-elem-button",
    --         elem_type = "item"
    --     }
    --     local l0 = t0.add{
    --         type = "label",
    --         caption = i % 2 *100,
    --         ignore_interaction = true
    --     }
    --     l0.style.height = 15
    --     l0.style.width = 30
    -- end
    -- for i=1,2 do
    --     local t = testFrame.add{
    --         type = "choose-elem-button",
    --         elem_type = "item"
    --     }
    --     local top = t.add{
    --         type = "label",
    --         caption = i % 2 *100,
    --         ignore_interaction = true
    --     }
    --     top.style.height = 36
    --     top.style.width = 36
    --     top.style.vertical_align = "top"
    --     local bottom = t.add{
    --         type = "label",
    --         caption = i % 2 * 100,
    --         ignore_interaction = true
    --     }
    --     bottom.style.height = 36
    --     bottom.style.width = 36
    --     bottom.style.vertical_align = "bottom"
    -- end
end

script.on_event(defines.events.on_player_created, on_player_created)
script.on_event(defines.events.on_gui_click, function(event)
    local player = game.get_player(event.player_index)
    local testFrame = mod_gui.get_frame_flow(player).testFrame

    if event.element.name == "reset" then
        testFrame.destroy()
        on_player_created(event)
    elseif event.element.name == "clearIt" then
        for i, child in pairs(testFrame.children) do
            if child.type == "label" then
                child.caption = ""
            else
                for c, _ in pairs(child.children) do
                    child.children[c].caption = ""
                end
            end
        end
    end
end)